Module javafx.graphics
Package javafx.animation

# Class FillTransition

java.lang.Object
javafx.animation.Animation
javafx.animation.Transition
javafx.animation.FillTransition

    public final class FillTransition
    extends Transition

This `Transition` creates an animation, that changes the filling of a shape over a `duration`. This is done by updating the `fill` variable of the `shape` at regular intervals.

It starts from the `fromValue` if provided else uses the `shape` 's `fill` value. (The `stroke` value has to be a `Color` in this case).

It stops at the `toValue` value.

Code Segment Example:

     import javafx.scene.shape.*;
     import javafx.animation.*;

     ...

         Rectangle rect = new Rectangle (100, 40, 100, 100);
         rect.setArcHeight(50);
         rect.setArcWidth(50);

         FillTransition ft = new FillTransition(Duration.millis(3000), rect, Color.RED, Color.BLUE);
         ft.setCycleCount(4);
         ft.setAutoReverse(true);

         ft.play();

     ...

Since:
  JavaFX 2.0
See Also:
  `Transition`, `Animation`

- ## Property Summary

  Properties
  Type | Property | Description
  --- | --- | ---
  `ObjectProperty<Duration>` | `duration` | The duration of this `FillTransition`.
  `ObjectProperty<Color>` | `fromValue` | Specifies the start color value for this `FillTransition`.
  `ObjectProperty<Shape>` | `shape` | The target shape of this `FillTransition`.
  `ObjectProperty<Color>` | `toValue` | Specifies the stop color value for this `FillTransition`.

  ### Properties inherited from class javafx.animation.Transition

  `interpolator`

  ### Properties inherited from class javafx.animation.Animation

  `autoReverse, currentRate, currentTime, cycleCount, cycleDuration, delay, onFinished, rate, status, totalDuration`

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class javafx.animation.Animation

  `Animation.Status`

- ## Field Summary

  ### Fields inherited from class javafx.animation.Animation

  `INDEFINITE`

- ## Constructor Summary

  Constructors
  Constructor | Description
  --- | ---
  `FillTransition()` | The constructor of `FillTransition`
  `FillTransition​(Duration duration)` | The constructor of `FillTransition`
  `FillTransition​(Duration duration, Color fromValue, Color toValue)` | The constructor of `FillTransition`
  `FillTransition​(Duration duration, Shape shape)` | The constructor of `FillTransition`
  `FillTransition​(Duration duration, Shape shape, Color fromValue, Color toValue)` | The constructor of `FillTransition`

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `ObjectProperty<Duration>` | `durationProperty()` | The duration of this `FillTransition`.
  `ObjectProperty<Color>` | `fromValueProperty()` | Specifies the start color value for this `FillTransition`.
  `Duration` | `getDuration()` | Gets the value of the property duration.
  `Color` | `getFromValue()` | Gets the value of the property fromValue.
  `Shape` | `getShape()` | Gets the value of the property shape.
  `Color` | `getToValue()` | Gets the value of the property toValue.
  `protected void` | `interpolate​(double frac)` | The method `interpolate()` has to be provided by implementations of `Transition`.
  `void` | `setDuration​(Duration value)` | Sets the value of the property duration.
  `void` | `setFromValue​(Color value)` | Sets the value of the property fromValue.
  `void` | `setShape​(Shape value)` | Sets the value of the property shape.
  `void` | `setToValue​(Color value)` | Sets the value of the property toValue.
  `ObjectProperty<Shape>` | `shapeProperty()` | The target shape of this `FillTransition`.
  `ObjectProperty<Color>` | `toValueProperty()` | Specifies the stop color value for this `FillTransition`.

  ### Methods inherited from class javafx.animation.Transition

  `getCachedInterpolator, getInterpolator, getParentTargetNode, interpolatorProperty, setInterpolator`

  ### Methods inherited from class javafx.animation.Animation

  `autoReverseProperty, currentRateProperty, currentTimeProperty, cycleCountProperty, cycleDurationProperty, delayProperty, getCuePoints, getCurrentRate, getCurrentTime, getCycleCount, getCycleDuration, getDelay, getOnFinished, getRate, getStatus, getTargetFramerate, getTotalDuration, isAutoReverse, jumpTo, jumpTo, onFinishedProperty, pause, play, playFrom, playFrom, playFromStart, rateProperty, setAutoReverse, setCycleCount, setCycleDuration, setDelay, setOnFinished, setRate, setStatus, statusProperty, stop, totalDurationProperty`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Property Details

  - ### shape

    public final ObjectProperty<Shape> shapeProperty
    The target shape of this `FillTransition`.

    It is not possible to change the target `shape` of a running `FillTransition`. If the value of `shape` is changed for a running `FillTransition`, the animation has to be stopped and started again to pick up the new value.

    See Also:
      `getShape()`, `setShape(Shape)`

  - ### duration

    public final ObjectProperty<Duration> durationProperty
    The duration of this `FillTransition`.

    It is not possible to change the `duration` of a running `FillTransition`. If the value of `duration` is changed for a running `FillTransition`, the animation has to be stopped and started again to pick up the new value.

    Note: While the unit of `duration` is a millisecond, the granularity depends on the underlying operating system and will in general be larger. For example animations on desktop systems usually run with a maximum of 60fps which gives a granularity of ~17 ms. Setting duration to value lower than `Duration.ZERO` will result in `IllegalArgumentException`.

    Default value:
      400ms
    See Also:
      `getDuration()`, `setDuration(Duration)`

  - ### fromValue

    public final ObjectProperty<Color> fromValueProperty
    Specifies the start color value for this `FillTransition`.

    It is not possible to change `fromValue` of a running `FillTransition`. If the value of `fromValue` is changed for a running `FillTransition`, the animation has to be stopped and started again to pick up the new value.

    Default value:
      `null`
    See Also:
      `getFromValue()`, `setFromValue(Color)`

  - ### toValue

    public final ObjectProperty<Color> toValueProperty
    Specifies the stop color value for this `FillTransition`.

    It is not possible to change `toValue` of a running `FillTransition`. If the value of `toValue` is changed for a running `FillTransition`, the animation has to be stopped and started again to pick up the new value.

    Default value:
      `null`
    See Also:
      `getToValue()`, `setToValue(Color)`

- ## Constructor Details

  - ### FillTransition

    public FillTransition​(Duration duration, Shape shape, Color fromValue, Color toValue)
    The constructor of `FillTransition`
    Parameters:
      `duration` - The duration of the `FillTransition`
      `shape` - The `shape` which filling will be animated
      `fromValue` - The start value of the color-animation
      `toValue` - The end value of the color-animation

  - ### FillTransition

    public FillTransition​(Duration duration, Color fromValue, Color toValue)
    The constructor of `FillTransition`
    Parameters:
      `duration` - The duration of the `FillTransition`
      `fromValue` - The start value of the color-animation
      `toValue` - The end value of the color-animation

  - ### FillTransition

    public FillTransition​(Duration duration, Shape shape)
    The constructor of `FillTransition`
    Parameters:
      `duration` - The duration of the `FillTransition`
      `shape` - The `shape` which filling will be animated

  - ### FillTransition

    public FillTransition​(Duration duration)
    The constructor of `FillTransition`
    Parameters:
      `duration` - The duration of the `FadeTransition`

  - ### FillTransition

    public FillTransition()
    The constructor of `FillTransition`

- ## Method Details

  - ### setShape

    public final void setShape​(Shape value)
    Sets the value of the property shape.
    Property description:
      The target shape of this `FillTransition`.

      It is not possible to change the target `shape` of a running `FillTransition`. If the value of `shape` is changed for a running `FillTransition`, the animation has to be stopped and started again to pick up the new value.

  - ### getShape

    public final Shape getShape()
    Gets the value of the property shape.
    Property description:
      The target shape of this `FillTransition`.

      It is not possible to change the target `shape` of a running `FillTransition`. If the value of `shape` is changed for a running `FillTransition`, the animation has to be stopped and started again to pick up the new value.

  - ### shapeProperty

    public final ObjectProperty<Shape> shapeProperty()
    The target shape of this `FillTransition`.

    It is not possible to change the target `shape` of a running `FillTransition`. If the value of `shape` is changed for a running `FillTransition`, the animation has to be stopped and started again to pick up the new value.

    See Also:
      `getShape()`, `setShape(Shape)`

  - ### setDuration

    public final void setDuration​(Duration value)
    Sets the value of the property duration.
    Property description:
      The duration of this `FillTransition`.

      It is not possible to change the `duration` of a running `FillTransition`. If the value of `duration` is changed for a running `FillTransition`, the animation has to be stopped and started again to pick up the new value.

      Note: While the unit of `duration` is a millisecond, the granularity depends on the underlying operating system and will in general be larger. For example animations on desktop systems usually run with a maximum of 60fps which gives a granularity of ~17 ms. Setting duration to value lower than `Duration.ZERO` will result in `IllegalArgumentException`.

    Default value:
      400ms

  - ### getDuration

    public final Duration getDuration()
    Gets the value of the property duration.
    Property description:
      The duration of this `FillTransition`.

      It is not possible to change the `duration` of a running `FillTransition`. If the value of `duration` is changed for a running `FillTransition`, the animation has to be stopped and started again to pick up the new value.

      Note: While the unit of `duration` is a millisecond, the granularity depends on the underlying operating system and will in general be larger. For example animations on desktop systems usually run with a maximum of 60fps which gives a granularity of ~17 ms. Setting duration to value lower than `Duration.ZERO` will result in `IllegalArgumentException`.

    Default value:
      400ms

  - ### durationProperty

    public final ObjectProperty<Duration> durationProperty()
    The duration of this `FillTransition`.

    It is not possible to change the `duration` of a running `FillTransition`. If the value of `duration` is changed for a running `FillTransition`, the animation has to be stopped and started again to pick up the new value.

    Note: While the unit of `duration` is a millisecond, the granularity depends on the underlying operating system and will in general be larger. For example animations on desktop systems usually run with a maximum of 60fps which gives a granularity of ~17 ms. Setting duration to value lower than `Duration.ZERO` will result in `IllegalArgumentException`.

    Default value:
      400ms
    See Also:
      `getDuration()`, `setDuration(Duration)`

  - ### setFromValue

    public final void setFromValue​(Color value)
    Sets the value of the property fromValue.
    Property description:
      Specifies the start color value for this `FillTransition`.

      It is not possible to change `fromValue` of a running `FillTransition`. If the value of `fromValue` is changed for a running `FillTransition`, the animation has to be stopped and started again to pick up the new value.

    Default value:
      `null`

  - ### getFromValue

    public final Color getFromValue()
    Gets the value of the property fromValue.
    Property description:
      Specifies the start color value for this `FillTransition`.

      It is not possible to change `fromValue` of a running `FillTransition`. If the value of `fromValue` is changed for a running `FillTransition`, the animation has to be stopped and started again to pick up the new value.

    Default value:
      `null`

  - ### fromValueProperty

    public final ObjectProperty<Color> fromValueProperty()
    Specifies the start color value for this `FillTransition`.

    It is not possible to change `fromValue` of a running `FillTransition`. If the value of `fromValue` is changed for a running `FillTransition`, the animation has to be stopped and started again to pick up the new value.

    Default value:
      `null`
    See Also:
      `getFromValue()`, `setFromValue(Color)`

  - ### setToValue

    public final void setToValue​(Color value)
    Sets the value of the property toValue.
    Property description:
      Specifies the stop color value for this `FillTransition`.

      It is not possible to change `toValue` of a running `FillTransition`. If the value of `toValue` is changed for a running `FillTransition`, the animation has to be stopped and started again to pick up the new value.

    Default value:
      `null`

  - ### getToValue

    public final Color getToValue()
    Gets the value of the property toValue.
    Property description:
      Specifies the stop color value for this `FillTransition`.

      It is not possible to change `toValue` of a running `FillTransition`. If the value of `toValue` is changed for a running `FillTransition`, the animation has to be stopped and started again to pick up the new value.

    Default value:
      `null`

  - ### toValueProperty

    public final ObjectProperty<Color> toValueProperty()
    Specifies the stop color value for this `FillTransition`.

    It is not possible to change `toValue` of a running `FillTransition`. If the value of `toValue` is changed for a running `FillTransition`, the animation has to be stopped and started again to pick up the new value.

    Default value:
      `null`
    See Also:
      `getToValue()`, `setToValue(Color)`

  - ### interpolate

    protected void interpolate​(double frac)
    The method `interpolate()` has to be provided by implementations of `Transition`. While a `Transition` is running, this method is called in every frame. The parameter defines the current position with the animation. At the start, the fraction will be `0.0` and at the end it will be `1.0`. How the parameter increases, depends on the `interpolator`, e.g. if the `interpolator` is `Interpolator.LINEAR`, the fraction will increase linear. This method must not be called by the user directly.
    Specified by:
      `interpolate` in class `Transition`
    Parameters:
      `frac` - The relative position